package pop;

//simulates interacting laboratory populations
//i.e. the population size depends not only on this pop's size
//last step but also on the numbers of another pop (predator/prey)
//in the literature known as Lotka-Volterra model

public class Predator extends labPop{

public Prey rabbits;
//initially very stable (initial pop ~70) values, can be changed via setX
public double killRate=0.007; //death rate per encounter of rabbits due to predation
public double deathRate=0.2;  //even predators die, but naturally
public double efficiency=1.4;//how good can this predator turn
                              //prey into new predators

public void setDeathRate(double val){
deathRate=val;
}
public void setEfficiency(double val){
efficiency=val;
}
public void setKillRate(double val){
killRate=val;
}

public Predator(double init, listener report){
super(init,report);
}

public Predator(double init, listener report, Prey foxes){
this(init,report);
this.rabbits=rabbits;
}

public void changePrey(Prey rabbits){
this.rabbits=rabbits;
}

public double next(){
lastVal=efficiency*killRate*rabbits.lastVal*lastVal-deathRate*lastVal;
if(report!=null)
  report.add(lastVal);
return lastVal;
}

}
