package pop;

//simulates interacting laboratory populations
//i.e. the population size depends not only on this pop's size
//last step but also on the numbers of another pop (predator/prey)
//in the literature known as Lotka-Volterra model

public class Prey extends labPop{

public Predator foxes;

//initially very stable (initial pop ~140) value, can be changed via setX
public double birthRate=1.6;  //natural growth rate without predation

public Prey(double init, listener report){
super(init,report);
}

public void setBirthRate(double val){
birthRate=val;
}

public Prey(double init, listener report, Predator foxes){
this(init,report);
this.foxes=foxes;
}

public void changePredator(Predator foxes){
this.foxes=foxes;
}

public double next(){
lastVal=birthRate*lastVal - foxes.killRate*lastVal*foxes.lastVal;
if(report!=null)
  report.add(lastVal);
return lastVal;
}


}
